﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel.Composition;
using System.ComponentModel.Composition.Hosting;
using MEFInterfaces;


namespace MEFConsoleApp1
{
    class RunDemo
    {

        [Import(typeof(IToDo))]
        public IEnumerable<IToDo> ToDoList { get; set; }
        //public IToDo MyTask {get; set;}

        public RunDemo()
        {
            string folderToWatch = System.Configuration.ConfigurationSettings.AppSettings["MEFExportFolder"]; //@"C:\Development\MEF\DGCode\MEFDemo2\MEFComponent1\bin\Debug";
            var catalog = new DirectoryCatalog(folderToWatch);
            var container = new CompositionContainer(catalog);
            var batch = new CompositionBatch();
            batch.AddPart(this);
            container.Compose(batch);

        }

        public void RunTheDemo()
        {
            //Console.WriteLine(string.Format("It takes {0} hours to do the task: {1}.", MyTask.HoursRequired, MyTask.TaskName));
            foreach (var td in ToDoList)
            {
                Console.WriteLine(string.Format("It takes {0} hours to do the task: {1}.", td.HoursRequired, td.TaskName));
            }
        }
    }
}
